@echo on

rem fetch configuration values
call "%~sdp0..\..\Configuration\Configuration.bat"

rem drop the existing publish folder
if exist "%PUBLISHPATH%" rmdir /Q /S "%PUBLISHPATH%"

rem clean up before the debug build
"%DEVENVEXEFILE%" "%SOLUTIONFILE%" /Clean Debug
if %ERRORLEVEL% NEQ 0 goto END

rem backup the assembly info
copy /Y "%ASSEMBLYINFO%" "%BACKUPASSEMBLYINFO%"

if %ERRORLEVEL% NEQ 0 goto END

rem get the hg information ... the path must be passed like this or it fails
hg parent --repository "%ROOTPATH%" > "%HGTEMPFILE%"
if %ERRORLEVEL% equ -1 goto SKIPHG
if %ERRORLEVEL% neq 0 goto END

rem pull the revision number from the temp file
for /f "tokens=1,2 delims=: " %%i in ('findstr %CHANGESETTAG% "%HGTEMPFILE%"') do set BUILD=%%j
if %ERRORLEVEL% neq 0 goto END

rem fail if the revision was not found
if not defined BUILD goto SKIPHG

rem update the assembly info
%WINDIR%\system32\cscript.exe //B "%WSCRIPTREPLACEFILE%" "%ASSEMBLYINFO%" "%MAJOR%.%MINOR%.%REVISION%.0" "%MAJOR%.%MINOR%.%REVISION%.%BUILD%"
if %ERRORLEVEL% NEQ 0 goto END

:SKIPHG

rem do the relese build
"%DEVENVEXEFILE%" "%SOLUTIONFILE%" /Build Release
if %ERRORLEVEL% NEQ 0 goto END

rem revert to the old assembly info
copy /Y "%BACKUPASSEMBLYINFO%" "%ASSEMBLYINFO%"
if %ERRORLEVEL% NEQ 0 goto END

rem delete the backup
del /Q /S "%BACKUPASSEMBLYINFO%"
if %ERRORLEVEL% NEQ 0 goto END

rem create the chm file
%MSBUILDFILE% "%SANDCASTLECHMFILE%"
if %ERRORLEVEL% NEQ 0 goto END

rem create the website folder
%MSBUILDFILE% "%SANDCASTLEWEBSITEFILE%"
if %ERRORLEVEL% NEQ 0 goto END

rem make the publish folder
mkdir "%PUBLISHPATH%"


rem create the zip file
"%ZIPFILEEXE%" a "%PUBLISHZIPFILESTART%%BUILD%%PUBLISHZIPFILEEND%" "%RELEASEDLLFILE%" "%CONTENTRENDERINGDLLFILE%" "%RELEASECHMFILE%"
if %ERRORLEVEL% NEQ 0 goto END

rem move the website folder
move "%RELEASEWEBSITEPATH%" "%PUBLISHWEBSITEPATH%"
if %ERRORLEVEL% NEQ 0 goto END

rem clean up after the release build
"%DEVENVEXEFILE%" "%SOLUTIONFILE%" /Clean Release
if %ERRORLEVEL% NEQ 0 goto END

rem jump over the error code
goto END

:ERROREND

rem the error level needs to be set
set ERRORLEVEL=1

:END

rem record the exit code
set EXITCODE=%ERRORLEVEL%

rem should the script pause or continue
if "%1"=="BATCH" exit %EXITCODE%

rem wait for a response then exit
pause
