﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using SmoLiteApi.Sql;
using System.Data.SqlClient;
using SmoLiteApi.Helper;

namespace SmoLiteApi
{
    /// <summary/>
    public class DatabaseExtendedPropertyCollection : IEnumerable<DatabaseExtendedProperty>
    {
        private Database _database;

        /// <summary/>
        internal DatabaseExtendedPropertyCollection(Database database)
        {
            this._database = database;
        }

        /// <summary/>
        public DatabaseExtendedProperty this[string name]
        {
            get
            {
                // get the list
                List<DatabaseExtendedProperty> extendedProperties = this.FetchObjects(name);

                // return the data
                if (extendedProperties.Count == 0)
                {
                    return null;
                }

                // return the one and only
                return extendedProperties[0];
            }
        }

        /// <summary/>
        public IEnumerator<DatabaseExtendedProperty> GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        private List<DatabaseExtendedProperty> FetchObjects(string name)
        {
            List<DatabaseExtendedProperty> extendedProperties = new List<DatabaseExtendedProperty>();

            DatabaseExtendedPropertySelectSql databaseExtendedPropertySelectSql = new DatabaseExtendedPropertySelectSql();

            // set attributes
            databaseExtendedPropertySelectSql.AddObject(new { Name = name });

            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchSqlCommand(this._database.SqlConnection, databaseExtendedPropertySelectSql.Render()))
            {
                using (SqlDataReader sqlDataReader = sqlCommandHelper.ExecuteReader())
                {
                    while (sqlDataReader.Read())
                    {
                        DatabaseExtendedProperty databaseExtendedProperty = new DatabaseExtendedProperty(
                            this._database,
                            sqlDataReader.GetString(sqlDataReader.GetOrdinal(Constant.PARAMETER_NAME)));

                        // set attributes
                        databaseExtendedProperty.Value = sqlDataReader.GetString(sqlDataReader.GetOrdinal(Constant.PARAMETER_VALUE));

                        // add to the list
                        extendedProperties.Add(databaseExtendedProperty);
                    }
                }
            }

            // retun the list
            return extendedProperties;
        }
    }
}
