﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using SmoLiteApi.Sql;
using System.Data.SqlClient;
using SmoLiteApi.Helper;

namespace SmoLiteApi
{
    /// <summary/>
    public class DatabaseRoleCollection : IEnumerable<DatabaseRole>
    {
        private Database _database;

        /// <summary/>
        internal DatabaseRoleCollection(Database database)
        {
            this._database = database;
        }

        /// <summary/>
        public DatabaseRole this[string name]
        {
            get
            {
                // get the list
                List<DatabaseRole> databaseRoles = this.FetchObjects(name);

                // return the data
                if (databaseRoles.Count == 0)
                {
                    return null;
                }

                // return the one and only
                return databaseRoles[0];
            }
        }

        /// <summary/>
        public IEnumerator<DatabaseRole> GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        private List<DatabaseRole> FetchObjects(string name)
        {
            List<DatabaseRole> databaseRoles = new List<DatabaseRole>();

            DatabaseRoleSelectSql databaseRoleSelectSql = new DatabaseRoleSelectSql();

            // set attributes
            databaseRoleSelectSql.AddObject(new { Name = name });

            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchSqlCommand(this._database.SqlConnection, databaseRoleSelectSql.Render()))
            {
                using (SqlDataReader sqlDataReader = sqlCommandHelper.ExecuteReader())
                {
                    while (sqlDataReader.Read())
                    {
                        DatabaseRole databaseRole = new DatabaseRole(
                            this._database,
                            sqlDataReader.GetString(sqlDataReader.GetOrdinal(Constant.PARAMETER_NAME)));

                        // add to the list
                        databaseRoles.Add(databaseRole);
                    }
                }
            }

            // retun the list
            return databaseRoles;
        }
    }
}
