﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using SmoLiteApi.Helper;
using SmoLiteApi.Sql;

namespace SmoLiteApi
{
    /// <summary/>
    public class FullTextCatalogCollection : IEnumerable<FullTextCatalog>
    {
        private Database _database;

        /// <summary/>
        internal FullTextCatalogCollection(Database database)
        {
            this._database = database;
        }

        /// <summary/>
        public FullTextCatalog this[string name]
        {
            get
            {
                // get the list
                List<FullTextCatalog> FullTextCatalogs = this.FetchObjects(name);

                // return the data
                if (FullTextCatalogs.Count == 0)
                {
                    return null;
                }

                // return the one and only
                return FullTextCatalogs[0];
            }
        }

        /// <summary/>
        public IEnumerator<FullTextCatalog> GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        private List<FullTextCatalog> FetchObjects(string name)
        {
            List<FullTextCatalog> FullTextCatalogs = new List<FullTextCatalog>();

            FullTextCatalogSelectSql FullTextCatalogSelectSql = new FullTextCatalogSelectSql();

            // set attributes
            FullTextCatalogSelectSql.AddObject(new { Name = name });

            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchSqlCommand(this._database.SqlConnection, FullTextCatalogSelectSql.Render()))
            {
                using (SqlDataReader sqlDataReader = sqlCommandHelper.ExecuteReader())
                {
                    while (sqlDataReader.Read())
                    {
                        FullTextCatalog FullTextCatalog = new FullTextCatalog(
                            this._database,
                            sqlDataReader.GetString(sqlDataReader.GetOrdinal(Constant.PARAMETER_NAME)));

                        // add to the list
                        FullTextCatalogs.Add(FullTextCatalog);
                    }
                }
            }

            // retun the list
            return FullTextCatalogs;
        }
    }
}
