﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using SmoLiteApi.Sql;
using System.Data.SqlClient;
using SmoLiteApi.Helper;

namespace SmoLiteApi
{
    /// <summary/>
    public class LoginCollection : IEnumerable<Login>
    {
        private Server _server;

        /// <summary/>
        internal LoginCollection(Server server)
        {
            this._server = server;
        }

        /// <summary/>
        public Login this[string name]
        {
            get
            {
                // get the list
                List<Login> logins = this.FetchObjects(name);

                // return the data
                if (logins.Count == 0)
                {
                    return null;
                }

                // return the one and only
                return logins[0];
            }
        }

        /// <summary/>
        public IEnumerator<Login> GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.FetchObjects(null).GetEnumerator();
        }

        /// <summary/>
        private List<Login> FetchObjects(string name)
        {
            List<Login> logins = new List<Login>();

            LoginSelectSql loginSelectSql = new LoginSelectSql();

            // set attributes
            loginSelectSql.AddObject(new { Name = name });

            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchSqlCommand(this._server.FetchSqlConnection(), loginSelectSql.Render()))
            {
                using (SqlDataReader sqlDataReader = sqlCommandHelper.ExecuteReader())
                {
                    while (sqlDataReader.Read())
                    {
                        Login login = new Login(
                            this._server,
                            sqlDataReader.GetString(sqlDataReader.GetOrdinal(Constant.PARAMETER_NAME)));

                        // add to the list
                        logins.Add(login);
                    }
                }
            }

            // retun the list
            return logins;
        }
    }
}
