﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SmoLiteApi.Sql;
using System.Data.SqlClient;
using SmoLiteApi.Helper;

namespace SmoLiteApi
{
    /// <summary/>
    public class Schema
    {
        private Database _database;
        private string _name;
        private string _user;
        private SchemaExtendedPropertyCollection _schemaExtendedPropertyCollection;

        /// <summary/>
        public Schema(
            Database database,
            string name)
        {
            this._database = database;
            this._name = name;
            this._schemaExtendedPropertyCollection = new SchemaExtendedPropertyCollection(this);
        }

        /// <summary/>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        /// <summary/>
        public string User
        {
            get { return this._user; }
            set { this._user = value; }
        }

        /// <summary/>
        public Database Parent
        {
            get { return this._database; }
        }

        /// <summary/>
        public SchemaExtendedPropertyCollection ExtendedProperties
        {
            get { return this._schemaExtendedPropertyCollection; }
        }

        /// <summary/>
        public void Create()
        {
            SchemaCreateSql userCreateSql = new SchemaCreateSql();

            // set attributes
            userCreateSql.AddObject(new { Name = this._name, User = this._user });

            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchSqlCommand(this._database.SqlConnection, userCreateSql.Render()))
            {
                // run the command
                sqlCommandHelper.ExecuteNonQuery();
            }
        }
    }
}
