﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using SmoLiteApi.Helper;

namespace SmoLiteApi
{
    /// <summary/>
    public class SchemaExtendedProperty
    {
        private Schema _schema;
        private string _name;
        private object _value;

        /// <summary/>
        public SchemaExtendedProperty(
            Schema schema,
            string name)
        {
            this._schema = schema;
            this._name = name;
        }

        /// <summary/>
        public void Create()
        {
            using (SqlCommandHelper sqlCommandHelper = SqlCommandHelper.FetchProcedureCommand(this._schema.Parent.SqlConnection, Constant.PROCEDURE_ADD_EXTENDED_PROPERTY))
            {
                // set inputs
                sqlCommandHelper.Parameters.Add(new SqlParameter(Constant.PARAMETER_NAME, this._name));
                sqlCommandHelper.Parameters.Add(new SqlParameter(Constant.PARAMETER_VALUE, this._value));
                sqlCommandHelper.Parameters.Add(new SqlParameter(Constant.PARAMETER_LEVEL_ZERO_TYPE, Constant.EXTENDED_PROPERTY_SCHEMA));
                sqlCommandHelper.Parameters.Add(new SqlParameter(Constant.PARAMETER_LEVEL_ZERO_NAME, this._schema.Name));

                // run the command
                sqlCommandHelper.ExecuteNonQuery();
            }
        }

        /// <summary/>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        /// <summary/>
        public object Value
        {
            get { return this._value; }
            set { this._value = value; }
        }
    }
}
