﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ContentRenderingApi;

namespace SmoLiteApi.Sql
{
    /// <summary/>
    internal class ForeignKeyCreateSql : AbstractSql
    {
        /// <summary/>
        protected override string TemplateTypeName
        {
            get { return Constant.TEMPLATE_TYPE_NAME_FOREIGN_KEY_CREATE; }
        }

        /// <summary/>
        protected override void ConfigureTemplate(AbstractTemplate template)
        {
            // add conditionals
            template.AddConditionalFunction(Constant.ATTRIBUTE_LAST, value => value.Position == value.Length);
            
            // remove carriage returns and line feeds
            template.AssignDocumentOverride(ForeignKeyCreateSql.RemoveLineFeeds);
        }

        /// <summary/>
        private static string RemoveLineFeeds(string value)
        {
            return value.Replace(Constant.STRING_LINE_FEED_CARRIAGE_RETURN, string.Empty);
        }
    }
}
